-- MySQL dump 8.22
--
-- Host: localhost    Database: mailscanner
---------------------------------------------------------
-- Server version	3.23.54

--
-- Current Database: mailscanner
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ mailscanner;

USE mailscanner;

--
-- Table structure for table 'inq'
--

CREATE TABLE inq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM;

--
-- Table structure for table 'maillog'
--

CREATE TABLE maillog (
  timestamp timestamp(14) NOT NULL,
  id text,
  size bigint(20) default '0',
  from_address text,
  to_address text,
  subject text,
  clientip text,
  archive text,
  isspam tinyint(1) default '0',
  ishighspam tinyint(1) default '0',
  issaspam tinyint(1) default '0',
  isrblspam tinyint(1) default '0',
  spamwhitelisted tinyint(1) default '0',
  sascore decimal(7,2) default '0.00',
  spamreport text,
  virusinfected tinyint(1) default '0',
  nameinfected tinyint(1) default '0',
  otherinfected tinyint(1) default '0',
  report text,
  hostname text,
  date date default NULL,
  time time default NULL,
  headers text,
  KEY date_idx (date)
) TYPE=MyISAM;

--
-- Table structure for table 'outq'
--

CREATE TABLE outq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM;

--
-- Table structure for table 'sa_rules'
--

CREATE TABLE sa_rules (
  rule varchar(100) NOT NULL default '',
  rule_desc varchar(200) NOT NULL default '',
  PRIMARY KEY  (rule)
) TYPE=MyISAM;

--
-- Table structure for table 'users'
--

CREATE TABLE users (
  username varchar(20) NOT NULL default '',
  password varchar(32) default NULL,
  fullname varchar(50) NOT NULL default '',
  PRIMARY KEY  (username)
) TYPE=MyISAM;

