<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require("./functions.php");
authenticate();
html_start("Message Detail ($_GET[id])");
$yes = "<SPAN CLASS=\"YES\">&nbsp;Y&nbsp;</SPAN>";
$no  = "<SPAN CLASS=\"NO\">&nbsp;N&nbsp;</SPAN>";

$sql = "
 SELECT
  DATE_FORMAT(timestamp, '%d/%m/%y %H:%i:%s') AS 'Received on:',
  hostname AS 'Received by:',
  clientip AS 'Received from:',
  id AS 'ID:',
  headers AS 'Message Headers:',
  from_address AS 'From:',
  to_address AS 'To:',
  subject AS 'Subject:',
  size AS 'Size:', 
  CASE WHEN virusinfected>0 THEN '$yes' ELSE '$no' END AS 'Virus:',
  CASE WHEN nameinfected>0 THEN '$yes' ELSE '$no' END AS 'Blocked File:',
  CASE WHEN otherinfected>0 THEN '$yes' ELSE '$no' END AS 'Other Infection:',
  report AS 'Report:',
  CASE WHEN isspam=1 THEN '$yes' ELSE '$no' END AS 'Spam:',
  CASE WHEN ishighspam=1 THEN '$yes' ELSE '$no' END AS 'High Scoring Spam:',
  CASE WHEN isrblspam=1 THEN '$yes' ELSE '$no' END AS 'Listed in RBL:',
  CASE WHEN spamwhitelisted=1 THEN '$yes' ELSE '$no' END AS 'Whitelisted:',
  CASE WHEN issaspam=1 THEN '$yes' ELSE '$no' END AS 'SpamAssassin Spam:',
  sascore AS 'SpamAssassin Score:',
  spamreport AS 'Spam Report:',
  archive AS 'Archive:'
 FROM
  maillog
 WHERE
  id = '$_GET[id]'
";

$result = dbquery($sql);

echo "<TABLE CLASS=\"maildetail\" WIDTH=100%>\n";
while($row=mysql_fetch_row($result)) {
 for($f=0; $f<mysql_num_fields($result); $f++) {
  $fieldn = mysql_field_name($result,$f);
  if ($fieldn == "Received from:") {
   // Lookup IP address
   $row[$f] = gethostbyaddr($row[$f])." ($row[$f]) - Check in <A HREF=\"http://openrbl.org/lookup?i=$row[$f]\">OpenRBL</A>\n";
  }
  if ($fieldn == "Report:") {
   $row[$f] = nl2br(str_replace(",","<BR/>",htmlentities($row[$f])));
  }
  if ($fieldn == "From:" || $fieldn == "To:" || $fieldn == "Subject:") {
   $row[$f] = htmlentities($row[$f]);
  }
  if ($fieldn == "To:") {
   $row[$f] = str_replace(",","<BR/>",$row[$f]);
  } 
  if ($fieldn == "Spam Report:") {
   $row[$f] = format_spam_report($row[$f]);
  }
  if ($fieldn == "Size:") {
   $row[$f] = format_mail_size($row[$f]);
  }
  if ($fieldn == "Message Headers:") {
   $row[$f] = nl2br(str_replace("\\n","<BR/>",htmlentities($row[$f])));
  }
  if ($fieldn == "Spam:") {
   // Display actions if spam/not-spam
   if($row[$f] == $yes && $row[$f+1] !== $yes) {
    $row[$f] = $row[$f]."&nbsp;&nbsp;Action(s): ".str_replace(" ",", ",get_conf_var("SpamActions"));
   } else {
    $row[$f] = $row[$f]."&nbsp;&nbsp;Actions(s): ".str_replace(" ",", ",get_conf_var("NonSpamActions"));
   }
  }
  if ($fieldn == "High Scoring Spam:" && $row[$f] == $yes) {
   // Display actions if high-scoring
   $row[$f] = $row[$f]."&nbsp;&nbsp;Action(s): ".str_replace(" ",", ",get_conf_var("HighScoringSpamActions"));
  }
  echo "<TR><TD CLASS=\"heading\" ALIGN=\"RIGHT\" VALIGN=\"TOP\" WIDTH=150>".mysql_field_name($result,$f)."</TD><TD CLASS=\"detail\">".$row[$f]."</TD></TR>\n";
 }
}
echo "</TABLE>\n";
echo "<BR>\n";

////////////////
// QUARANTINE //
////////////////

// Get required info from db
$row = mysql_fetch_object(dbquery("
SELECT 
 DATE_FORMAT(timestamp,'%Y%m%d') AS date, 
 id,
 to_address,
 CASE WHEN isspam>0 THEN 'Y' ELSE 'N' END AS isspam, 
 CASE WHEN nameinfected>0 THEN 'Y' ELSE 'N' END AS nameinfected,
 CASE WHEN virusinfected>0 THEN 'Y' ELSE 'N' END AS virusinfected,
 CASE WHEN otherinfected>0 THEN 'Y' ELSE 'N' END AS otherinfected
FROM
 maillog
WHERE
 id = '$_GET[id]'"));

$quarantinedir = get_conf_var("QuarantineDir");
$quarantine = $quarantinedir.'/'.$row->date.'/'.$row->id;
$spam = $quarantinedir."/".$row->date.'/spam/'.$row->id;
$notspam = $quarantinedir."/".$row->date.'/not-spam/'.$row->id;

if((@is_readable($quarantine) && is_dir($quarantine)) || (@file_exists($spam) && is_readable($spam)) || (@file_exists($notspam) && is_readable($notspam))) {
 $quarantined = array();
 $count = 0;
 // Check for not-spam first
 if(file_exists($notspam)) {
  $quarantined[$count]['id']		= $count;
  $quarantined[$count]['msgid']		= $row->id;
  $quarantined[$count]['file'] 		= "message";
  $quarantined[$count]['type'] 		= "message/rfc822";
  $quarantined[$count]['path'] 		= $notspam;
  $quarantined[$count]['md5'] 	 	= md5($notspam);
  $quarantined[$count]['dangerous'] 	= $row->virusinfected;
  $count++;
 }
 // Check for spam
 if(file_exists($spam)) {
  $quarantined[$count]['id']		= $count;
  $quarantined[$count]['msgid']		= $row->id;
  $quarantined[$count]['file']     	= "message";
  $quarantined[$count]['type']     	= "message/rfc822";
  $quarantined[$count]['path']     	= $spam;
  $quarantined[$count]['md5']      	= md5($spam);
  $quarantined[$count]['dangerous'] 	= $row->virusinfected;
  $count++;
 }
 // Check the main quarantine
 if(is_dir($quarantine)) {
  $d = opendir($quarantine) or die("Cannot open quarantine dir: $quarantine\n");
  while(false !== ($f = readdir($d))) {
   if($f !== '..' && $f !== '.') {
    $quarantined[$count]['id']		= $count;
    $quarantined[$count]['msgid']	= $row->id;
    $quarantined[$count]['file'] 	= $f;
    $file				= escapeshellarg($quarantine.'/'.$f);
    $quarantined[$count]['type'] 	= ltrim(rtrim(`/usr/bin/file -bi $file`));
    $quarantined[$count]['path'] 	= $quarantine.'/'.$f;
    $quarantined[$count]['md5']  	= md5($quarantine.'/'.$f);
    $quarantined[$count]['dangerous'] 	= $row->virusinfected;
    $count++;
   }
  }
  closedir($d);
 }


 if($_GET['submit'] == "Submit") {
  debug("submit branch taken");
  // Reset error status
  $error=0;
  // Release
  if(isset($_GET['release'])) {
   debug("release branch taken");
   // Load in the required PEAR modules
   include('Mail.php');
   include('Mail/mime.php');
   $text = "Original mail attached to this message";
   $crlf = "\r\n";
   $hdrs = array('From' => 'mailscanner@hoshi.lbsltd.co.uk', 'Subject' => 'Released quarantined message attached');
   $mime = new Mail_mime($crlf);
   $mime->setTXTBody($text);
   // Loop through each selected file and attach them to the mail
   foreach($_GET['release'] as $key=>$val) {
    // If the message is of rfc822 type then set it as Quoted printable
    if($quarantined[$val]['type'] == "message/rfc822") {
     $mime->addAttachment($quarantined[$val]['path'], $quarantined[$val]['type'], 'Original Message', true, 'Quoted printable');
    } else {
     // Default is base64 encoded
     $mime->addAttachment($quarantined[$val]['path'], $quarantied[$val]['type'], $quarantined[$val]['file'], true);
    }
   }
   $body = $mime->get();
   $hdrs = $mime->headers($hdrs);
   $mail =& Mail::factory('mail');
   // Send to the original recipient(s) or to an alternate address
   if(($_GET['alt_recpt_yn'] == "y")) {
    $to = $_GET['alt_recpt'];
   } else {
    $to = $row->to_address;
   }
   if(PEAR::isError($mail->send($to, $hdrs, $body))) {
    // Error
    $error=1;
    $errors[] = "Release: error ".PEAR_Error::getMessage();
   } else {
    $status[] = "Release: message released to ".str_replace(",",", ",$to);
   }
  }
  // sa-learn
  if(isset($_GET['learn'])) {
   foreach($_GET['learn'] as $key=>$val) {
    switch ($_GET['learn_type']) {
     case "ham":
      $learn_type = "ham";
      break;
     case "spam":
      $learn_type = "spam";
      break;
     case "forget":
      $learn_type = "forget";
      break;
    }
    if(exec('/usr/bin/sa-learn -p /etc/MailScanner/spam.assassin.prefs.conf --'.$learn_type.' --file '.$quarantined[$val]['path'].' 2>&1', $output_array, $retval) && $retval == 0) {
     $status[] = "SA Learn: ".join(", ",$output_array);
    } else {
     $error=1;
     $errors[] = "SA Learn: error code ".$retval." returned from sa-learn";
    } 
   }
  }
  // Delete
  if(isset($_GET['delete'])) {
   foreach($_GET['delete'] as $key=>$val) {
    if(!$error) {
     if(@unlink($quarantined[$val]['path'])) {
      $status[] = "Delete: deleted file ".$quarantined[$val]['path'];
     } else {
      $error=1; 
      $errors[] = "Delete: error deleting file ".$quarantined[$val]['path'];
     }
    } else {
     $error=1;
     $errors[] = "Delete: not deleting file ".$quarantined[$val]['path']." due to previous errors";
    }
   }
  }
  echo "<TABLE BORDER=0 WIDTH=\"100%\" CLASS=\"maildetail\">\n";
  echo " <THEAD>\n";
  echo "  <TH COLSPAN=2>Quarantine Command Results</TH>\n";
  echo " </THEAD>\n";
  if(isset($status)) {
   echo "  <TR>\n";
   echo "  <TD CLASS=\"heading\" WIDTH=150 ALIGN=\"RIGHT\" VALIGN=\"TOP\">Result Messages:</TD>\n";
   echo "  <TD CLASS=\"detail\">";
   foreach($status as $key=>$val) {
    echo "  $val<BR>\n";
   }
   echo "  </TD>\n";
   echo " </TR>\n";
  }
  if(isset($errors)) {
   echo " <TR>\n";
   echo "  <TD CLASS=\"heading\" WIDTH=150 ALIGN=\"RIGHT\" VALIGN=\"TOP\">Error Messages:</TD>\n";
   echo "  <TD CLASS=\"detail\">";
   foreach($errors as $key=>$val) {
    echo "  $val<BR>\n";
   }
   echo "  </TD>\n";
   echo " <TR>\n";
  }
  echo " <TR>\n";
  echo "  <TD CLASS=\"heading\" WIDTH=150 ALIGN=\"RIGHT\" VALIGN=\"TOP\">Error:</TD>\n";
  echo "  <TD CLASS=\"detail\">".($error?$yes:$no)."</TD>\n";
  echo " </TR>\n";
  echo "</TABLE>\n";
 } else {
  echo "<FORM ACTION=\"".$_SERVER['PHP_SELF']."\" NAME=\"quarantine\">\n";
  echo "<TABLE BORDER=0 WIDTH=\"100%\" CLASS=\"mail\">\n";
  echo " <THEAD>\n";
  echo "  <TH COLSPAN=7>Quarantine</TH>\n";
  echo " </THEAD>\n";
  echo " <THEAD>\n";
  echo "  <TH>Release</TH>\n";
  echo "  <TH>Delete</TH>\n";
  echo "  <TH>SA Learn</TH>\n";
  echo "  <TH>File</TH>\n";
  echo "  <TH>Type</TH>\n";
  echo "  <TH>Path</TH>\n";
  echo "  <TH>Dangerous?</TH>\n";
  echo " </THEAD>\n";
  foreach($quarantined as $item) {
   echo " <TR>\n";
   // Don't allow message to be released if it is marked as 'dangerous'
   // Currently this only applies to messages that contain viruses.
   if($item['dangerous'] !== "Y") {
    echo "  <TD ALIGN=\"CENTER\"><INPUT TYPE=\"checkbox\" NAME=\"release[]\" VALUE=\"".$item['id']."\"></TD>\n";
   } else {
    echo "<TD>&nbsp;&nbsp;</TD>\n";
   }
   echo "  <TD ALIGN=\"CENTER\"><INPUT TYPE=\"checkbox\" NAME=\"delete[]\" VALUE=\"".$item['id']."\"></TD>\n";
   // If the file is an rfc822 message then allow the file to be learnt
   // by SpamAssassin Bayesian learner as either spam or ham (sa-learn).
   if($item['type'] == "message/rfc822" || $item['file'] == "message" && (strtoupper(get_conf_var("UseSpamAssassin")) == "YES")) {
    echo "   <TD ALIGN=\"CENTER\"><INPUT TYPE=\"checkbox\" NAME=\"learn[]\" VALUE=\"".$item['id']."\"><SELECT NAME=\"learn_type\"><OPTION VALUE=\"ham\">As Ham</OPTION><OPTION VALUE=\"spam\">As Spam</OPTION><OPTION VALUE=\"forget\">Forget</OPTION></SELECT></TD>\n"; 
   } else {
    echo "   <TD>&nbsp&nbsp</TD>\n";
   }
   echo "  <TD>".$item['file']."</TD>\n";
   echo "  <TD>".$item['type']."</TD>\n";
   echo "  <TD>".$item['path']."</TD>\n";
   if($item['dangerous'] == "Y") {
    $dangerous = $yes;
   } elseif ($item['dangerous'] == "N") {
    $dangerous = $no;
   }
   echo "  <TD ALIGN=\"CENTER\">".$dangerous."</TD>\n";
   echo " </TR>\n";
  }
  echo " <TR>\n";
  echo "  <TD COLSPAN=6><INPUT TYPE=\"checkbox\" NAME=\"alt_recpt_yn\" VALUE=\"y\">&nbsp;Alternate Recipient(s):&nbsp;<INPUT TYPE=\"TEXT\" NAME=\"alt_recpt\" SIZE=100></TD>\n";
  echo "  <TD ALIGN=\"RIGHT\">\n";
  echo "<INPUT TYPE=\"HIDDEN\" NAME=\"id\" VALUE=\"".$row->id."\">\n";
  echo "<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n";
  echo "  </TD></TR>\n";
  echo "</TABLE>\n";
  echo "</FORM>\n";
 }
}
 
html_end();
?>
