<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

///////////////////////////////////////////////////////////////////////////////
// Settings - modify to suit your configuration
///////////////////////////////////////////////////////////////////////////////

// Debug messages
define(DEBUG, false);

// Database settings
define(DB_TYPE, 'mysql');
define(DB_USER, 'root');
define(DB_PASS, '');
define(DB_HOST, 'localhost');
define(DB_NAME, 'mailscanner');
define(DB_DSN, DB_TYPE.'://'.DB_USER.":".DB_PASS."@".DB_HOST."/".DB_NAME);

// Paths
define(MS_CONFIG_PATH, '/etc/MailScanner/');
define(CACHE_DIR, '/var/www/html/mailscanner/images/cache/'); // JpGraph cache
define(SA_RULES_DIR, '/usr/share/spamassassin/');

// Regex to pick up the virus names from the reports.
// Change this to match the output of one of your scanners.
define(VIRUS_REGEX, '/(\S+) was infected by (\S+)/');		// SophosSAVI
//define(VIRUS_REGEX, '/(.+) contains (\S+)/'); 		// ClamAV
//define(VIRUS_REGEX, '/(>>>) Virus \'(.+)\' found/');  	// Sophos
//define(VIRUS_REGEX, '/(.+) Infection: (\S+)/';		// F-prot
//define(VIRUS_REGEX, '/(.+) Found the (\S+) virus !!!/');	// McAfee

// Default number of results on Recent Messages and Message Listing Report
define(MAX_RESULTS, 50);
// Default refresh rate in seconds for the Recent Messages screen
define(STATUS_REFRESH, 30);

// Set the following to a value greater than zero to limit the length of the 
// From, To and Subject columns in the 'Recent Messages' screen. 
define(FROMTO_MAXLEN, 0);
define(SUBJECT_MAXLEN, 0);

// Display the inbound/outbound mail queue lengths
// Note: this only works with Sendmail, and you need to run mailq.php from cron
define(MAILQ, true);

// Force SSL connections only?
define(SSL_ONLY, false);

if (SSL_ONLY) {
 if (!$_SERVER['HTTPS'] == 'on') {
  header("Location: https://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF']);
  exit;
 }
}

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////

function html_start($title,$refresh=0,$cacheable=true) {
 if (!$cacheable) {
  // Cache control (as per PHP website)
  header("Expires: Sat, 10 May 2003 00:00:00 GMT");
  header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
 }
?>
<HTML>
<HEAD>
<TITLE>MailWatch for MailScanner - <?=$title?></TITLE>
<LINK REL="StyleSheet" TYPE="text/css" HREF="style.css">
<?
 if ($refresh > 0) {
  echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"$refresh\">";
 }
?>
</HEAD>
<BODY>
<TABLE BORDER=0 CELLPADDING=5 WIDTH=100%>
 <TR>
  <TD ALIGN="LEFT"><IMG SRC="images/mailscannerlogo.gif"></TD>
<?
if(MAILQ) {
 echo "  <TD ALIGN=\"RIGHT\" VALIGN=\"TOP\" WIDTH=20%>\n";
 $inq = mysql_result(dbquery("SELECT COUNT(*) FROM inq"),0);
 $outq = mysql_result(dbquery("SELECT COUNT(*) FROM outq"),0);
 echo "   <TABLE BORDER=0 CLASS=\"MAIL\" WIDTH=200>\n";
 echo "    <THEAD><TH ALIGN=\"CENTER\" COLSPAN=2>Mail Queue</TH></THEAD>\n";
 echo "    <TR><TD><A HREF=\"mailq.php?queue=inq\">Inbound Queue:</A></TD><TD>".$inq."</TD>\n";
 echo "    <TR><TD><A HREF=\"mailq.php?queue=outq\">Outbound Queue:</A></TD><TD>".$outq."</TD>\n";
 echo "   </TABLE>\n";
 echo "  </TD>\n";
}
?>
  <TD WIDTH=20% ALIGN="RIGHT">
<?
$sth = dbquery("
 SELECT
  COUNT(*) AS processed,
  SUM(CASE WHEN virusinfected>0 THEN 1 ELSE 0 END) AS virii,
  ROUND((SUM(CASE WHEN virusinfected>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS viriipercent,
  SUM(CASE WHEN nameinfected>0 THEN 1 ELSE 0 END) AS blockedfiles,
  ROUND((SUM(CASE WHEN nameinfected>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS blockedfilespercent,
  SUM(CASE WHEN otherinfected>0 THEN 1 ELSE 0 END) AS otherinfected,
  ROUND((SUM(CASE WHEN otherinfected>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS otherinfectedpercent,
  SUM(CASE WHEN isspam>0 THEN 1 ELSE 0 END) AS spam,
  ROUND((SUM(CASE WHEN isspam>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS spampercent,
  SUM(CASE WHEN ishighspam>0 THEN 1 ELSE 0 END) AS highspam,
  ROUND((SUM(CASE WHEN ishighspam>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS highspampercent,
  SUM(size) AS size 
 FROM
  maillog
 WHERE
  date = CURRENT_DATE()
");

while($row = mysql_fetch_object($sth)) {
 echo "<TABLE BORDER=0 CLASS=\"mail\" WIDTH=200>\n";
 echo " <THEAD><TH ALIGN=\"CENTER\" COLSPAN=3>Today's Totals</TH></THEAD>\n";
 echo " <TR><TD>Processed:</TD><TD ALIGN=\"RIGHT\">".$row->processed."</TD><TD ALIGN=\"RIGHT\">".format_mail_size($row->size)."</TD></TR>\n";
 echo " <TR><TD>Spam:</TD><TD ALIGN=\"RIGHT\">$row->spam</TD><TD ALIGN=\"RIGHT\">$row->spampercent%</TD></TR>\n";
 echo " <TR><TD>High Scoring Spam:</TD><TD ALIGN=\"RIGHT\">$row->highspam</TD><TD ALIGN=\"RIGHT\">$row->highspampercent%</TD></TR>\n";
 echo " <TR><TD>Virii:</TD><TD ALIGN=\"RIGHT\">$row->virii</TD><TD ALIGN=\"RIGHT\">$row->viriipercent%</TR>\n";
 echo " <TR><TD>Top Virus:</TD>".get_todays_top_virus()."</TR>\n";
 echo " <TR><TD>Blocked files:</TD><TD ALIGN=\"RIGHT\">$row->blockedfiles</TD><TD ALIGN=\"RIGHT\">$row->blockedfilespercent%</TD></TR>\n";
 echo " <TR><TD>Others:</TD><TD ALIGN=\"RIGHT\">$row->otherinfected</TD><TD ALIGN=\"RIGHT\">$row->otherinfectedpercent%</TD></TR>\n";
 echo "</TABLE>\n";
}
?>
  </TD>
 </TR>
 <TR>
  <TD COLSPAN=<?= MAILQ ? 3:2 ?>>
   <TABLE CLASS="navigation" WIDTH=100%>
    <TR ALIGN=CENTER>
     <TD WIDTH=20%><A HREF="status.php">Recent Messages</A></TD>
     <TD WIDTH=20%><A HREF="quarantine.php">Quarantine</A></TD>
     <TD WIDTH=20%><A HREF="reports.php">Reports</A></TD>
     <TD WIDTH=20%><A HREF="other.php">Other</A></TD>
     <TD WIDTH=20%><A HREF="docs.php">Documentation</A></TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
 <TR>
  <TD COLSPAN=3>
<?
 return $refresh;
}

function report_start($title) {
 // Cache control (as per PHP website)
 header("Expires: Sat, 10 May 2003 00:00:00 GMT");
 header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
 header("Cache-Control: no-store, no-cache, must-revalidate");
 header("Cache-Control: post-check=0, pre-check=0", false);
?>
<HTML>
<HEAD>
<TITLE>MailWatch for MailScanner Report: <?=$title?></TITLE>
<LINK REL="StyleSheet" TYPE="text/css" HREF="style.css">
</HEAD>
<BODY>
<?
}


function html_end($footer="") {
?>
  </TD>
 </TR>
</TABLE>
<?=$footer?>
</BODY>
</HTML>
<?
}

function dbconn() {
 $link = mysql_pconnect(DB_HOST,DB_USER,DB_PASS)
        or die ("Could not connect to database: ".mysql_error());
 mysql_select_db("mailscanner") or die("Could not select db: ".mysql_error());
 return $link;
}

function dbquery($sql) {
 dbconn();
 $result = mysql_query($sql) or die("<B>Error executing query: </B><BR/><BR/>".mysql_error()."<BR/><BR/><B>SQL:</B><BR/><PRE>$sql</PRE>");
 return $result;
}

function authenticate() {
 $user = $_SERVER['PHP_AUTH_USER'];
 $pass = $_SERVER['PHP_AUTH_PW'];
 $sql = "SELECT count(*) FROM users WHERE username='$user' AND password=md5('$pass')";
 $sth = dbquery($sql);
 $count = mysql_fetch_row($sth);
 if (isset($user) && isset($pass) && $count[0] > 0) {
  return;
 } else {
  header('WWW-Authenticate: Basic realm="MailWatch for MailScanner"');
  header('HTTP/1.0 401 Unauthorized');
  html_start("Not authenticated");
  echo "<TABLE CLASS=\"BOXTABLE\" WIDTH=100%><TR><TD><H1><FONT COLOR=\"RED\">Authentication Required!</FONT></H1>Your username and/or password are incorrect.</TD></TR>\n";
  html_end();
  exit;
 }
}

function format_spam_report($spamreport) {
 /* Run regex against the MailScanner spamreport
 picking out the (score=xx, required x, RULES...) */
 if(preg_match('/SpamAssassin \((.+?)\)/',$spamreport,$sa_rules)) {
  // Get rid of the first match from the array
  array_shift($sa_rules);
  // Split the array
  $sa_rules = explode(", ",$sa_rules[0]);
  // Check to make sure a check was actually run
  if ($sa_rules[0] == "Message larger than max testing size") {
   return $sa_rules[0];
  }
  // Get rid of the 'score=' and 'required' lines
  array_shift($sa_rules);
  array_shift($sa_rules);
  //
  $output_array = array();
  while(list($key,$val)=each($sa_rules)) {
   array_push($output_array,get_sa_rule_desc($val));
  }
  // Return the result as an html formatted string 
  return "<TABLE BORDER=0 CLASS=\"sa_rules_report\">".implode("\n",$output_array)."</TABLE>\n"; 
 } else {
  // Regular expression did not match, return unmodified report instead
  return $spamreport;
 }
}

function get_sa_rule_desc($rule) {
 // Check if SA scoring is enabled
 if(preg_match('/^(.+) (.+)$/',$rule,$regs)) {
  $rule = $regs[1];
  $rule_score = $regs[2];
 } else {
  $rule_score = "";
 }
 $result = dbquery("SELECT rule, rule_desc FROM sa_rules WHERE upper(rule)=upper('$rule')");
 $row = mysql_fetch_object($result,1);
 if ($row->rule && $row->rule_desc) {
  return("<TR><TD ALIGN=\"RIGHT\">$rule_score</TD><TD WIDTH=\"200\">$row->rule</TD><TD>$row->rule_desc</TD></TR>");
 } else {
  return "<TR><TD>$rule_score<TD>$rule</TD><TD>&nbsp;</TD></TR>";
 }
}

function return_sa_rule_desc($rule) {
 $result = dbquery("SELECT rule, rule_desc FROM sa_rules WHERE rule='$rule'");
 $row = mysql_fetch_object($result,1);
 return $row->rule_desc;
}
 

function get_todays_top_virus() {
 $sql = "
SELECT
 report
FROM
 maillog
WHERE
 report IS NOT NULL
AND
 report != \"\"
AND
 date = CURRENT_DATE()
";
 $result = dbquery($sql);
 $virus_array = array();
 while($row=mysql_fetch_object($result)) {
  if(preg_match(VIRUS_REGEX,$row->report,$virus_reports)) {
   $virus = $virus_reports[2];
   $virus_array[$virus]++;
  }
 }
 arsort($virus_array);
 reset($virus_array);
 // Get the topmost entry from the array
 if ((list($key, $val) = each($virus_array)) != "") {
  // Check and make sure there first placed isn't tied!
  $saved_key = $key;
  $saved_val = $val;
  list($key, $val) = each($virus_array);
  if ($val != $saved_val) {
   return "<TD COLSPAN=2 ALIGN=\"RIGHT\">$saved_key</TD>";
  } else {
   // Tied first place - return none
   return "<TD COLSPAN=2 ALIGN=\"RIGHT\">None</TD>";
  }
 } else {
  return "<TD COLSPAN=2 ALIGN=\"RIGHT\">None</TD>";
 }
}

function format_mail_size($size_in_bytes, $decimal_places=1) {
 // Setup common measurements
 $kb = 1024;		// Kilobyte
 $mb = 1024*$kb;	// Megabyte
 $gb = 1024*$mb;	// Gigabyte
 $tb = 1024*$gb;	// Terabyte
 if($size_in_bytes < $kb) {
  return $size_in_bytes."b";
 } else if ($size_in_bytes < $mb) {
  return round($size_in_bytes/$kb,$decimal_places)."Kb";
 } else if ($size_in_bytes < $gb) {
  return round($size_in_bytes/$mb,$decimal_places)."Mb";
 } else if ($size_in_bytes < $tb) {
  return round($size_in_bytes/$gb,$decimal_places)."Gb";
 } else {
  return round($size_in_bytes/$tb,$decimal_places)."Tb";
 }
}

function format_report_volume($data_in, $info_out) {
 // Measures
 $kb = 1024;
 $mb = 1024*$kb;
 $gb = 1024*$mb;
 $tb = 1024*$gb;

 // Copy the data to a temporary variable
 $temp = $data_in;

 // Work out the average size of values in the array
 $count = count($temp);
 $sum = array_sum($temp);
 $average = $sum/$count;

 // Work out the largest value in the array
 arsort($temp);
 $largest = array_pop($temp);

 // Calculate the correct display size for the average value
 if($average < $kb) {
  $info_out['formula'] = 0;
  $info_out['shortdesc'] = "b";
  $info_out['longdesc'] = "Bytes";
 } else if ($average < $mb) {
  $info_out['formula'] = $kb;
  $info_out['shortdesc'] = "Kb";
  $info_out['longdesc'] = "Kilobytes";
 } else if ($average < $gb) {
  $info_out['formula'] = $mb;
  $info_out['shortdesc'] = "Mb";
  $info_out['longdesc'] = "Megabytes";
 } else if ($average < $tb) {
  $info_out['formula'] = $gb;
  $info_out['shortdesc'] = "Gb";
  $info_out['longdesc'] = "Gigabytes";
 } else {
  $info_out['formula'] = $tb;
  $info_out['shortdesc'] = "Tb";
  $info_out['longdesc'] = "Terabytes";
 }

 // Modify the original data accordingly
 for($i=0; $i<sizeof($data_in); $i++) {
  $data_in[$i] = $data_in[$i]/$info_out['formula'];
 }
}

function trim_output($input, $maxlen) {
 if (strlen($input) >= $maxlen) {
  $output = substr($input, 0, $maxlen)."...";
  return $output;
 } else {
  return $input;
 }
}


function get_conf_var($name) {
 $msconfig = MS_CONFIG_PATH."/MailScanner.conf";
 $fh = fopen($msconfig,'r') 
  or die("Cannot open MailScanner configuration file");
 while(!feof($fh)) {
  $line = rtrim(fgets($fh, filesize($msconfig)));
  if(preg_match('/^([^#].+) = ([^#].+)/',$line,$regs)) {
   $regs[1] = ereg_replace(' *', '', $regs[1]); 
   if((strtolower($regs[1])) == (strtolower($name))) {
    fclose($fh) or die($php_errormsg);
    return $regs[2];
   }
  }
 }
 fclose($fh) or die($php_errormsg);
 die("Cannot find configuration value: $name in $msconfig\n");
}

function translateQuarantineDate($date) {
 $y = substr($date,0,4);
 $m = substr($date,4,2);
 $d = substr($date,6,2);
 return "$d/$m/$y";
}

function dbtable($sql) {
 $sth = dbquery($sql);
 $rows = mysql_num_rows($sth);
 $fields = mysql_num_fields($sth);
 
 if($rows>0) {
  echo "<TABLE BORDER=0 WIDTH=\"100%\" CLASS=\"mail\">\n";
  // Column headings
  echo " <THEAD>\n";
  for($f=0;$f<$fields;$f++) {
   echo "  <TH>".mysql_field_name($sth,$f)."</TH>\n";
  } 
  echo " </THEAD>\n";
  // Rows
  while($row=mysql_fetch_row($sth)) {
   echo " <TR>\n";
   for($f=0;$f<$fields;$f++) {
    echo "  <TD>".$row[$f]."</TD>\n";
   }
   echo " </TR>\n";
  }
  echo "</TABLE>\n";
 } else {
  echo "No rows retrieved!\n";
 }
}

function debug($text) {
 if(DEBUG) {
  echo "<PRE>DEBUG: $text</PRE>\n";
 }
}
