<?
require("./functions.php");
authenticate();
html_start("Quarantine Viewer");

$quarantinedir = get_conf_var("QuarantineDir");

if(!isset($_GET['dir']) && !isset($_GET["msgdir"])) {
 // Display top level quarantine directories
 $d = opendir($quarantinedir) or die("Cannot open directory: $dir");
 while(false !== ($f = readdir($d))) {
  if ($f !== "." && $f !== "..") {
   $items[] = $f;
  }
 }
 // Sort in reverse chronological order
 arsort($items);
 echo "<TABLE CLASS=\"MAIL\" WIDTH=100% CELLPADDING=2 CELLSPACING=2>\n";
 echo "<THEAD><TH>Folder</TH></THEAD>\n"; 
 foreach($items as $f) {
  echo "<TR><TD ALIGN=\"CENTER\"><A HREF=\"".$_SERVER["PHP_SELF"]."?dir=$f\">".translateQuarantineDate($f)."</A></TD></TR>\n";
 }
 echo "</TABLE>\n";
 closedir($d);  
} else {
 // SECURITY: trim off any potential nasties
 $_GET['dir'] = preg_replace('[\.|\.\.|\/]','',$_GET['dir']);
 $items = array();
 // Check file quarantine
 $quarantinepath = $quarantinedir."/".$_GET['dir'];
 if($d = @opendir($quarantinepath)) {
  while(false !== ($f = readdir($d))) {
   if($f != "." && $f != ".." && $f != "spam") {
    $items[] = "'".$f."'";
   }
  }
  closedir($d);
 } else {
  die("Could not open $quarantinepath.\n<BR>");
 }
 // Check spam quarantine
 $spamquarantine = $quarantinepath."/spam/";
 if (@is_dir($spamquarantine)) {
  if($d = @opendir($quarantinepath."/spam/")) {
   while(false !== ($f = readdir($d))) {
    if($f != "." && $f != "..") {
     $items[] = "'".$f."'";
    }
   }
   closedir($d);
  } else {
   echo "Could not open $spamquarantine.\n<BR>";
  }
 }
 // Build list of message id's to be used in SQL statement
 $msg_ids = join($items, ",");
 $sql = "
SELECT
 DATE_FORMAT(timestamp, '%d/%m/%y %h:%i:%s') AS datetime,
 id,
 from_address,
 to_address,
 subject,
 size,
 sascore,
 report,
 CASE WHEN isspam>0 THEN 'Y' ELSE 'N' END AS isspam,
 CASE WHEN virusinfected>0 THEN 'Y' ELSE 'N' END AS virusinfected,
 CASE WHEN nameinfected>0 THEN 'Y' ELSE 'N' END AS nameinfected,
 CASE WHEN otherinfected>0 THEN 'Y' ELSE 'N' END AS otherinfected
FROM
 maillog
WHERE
 id IN ($msg_ids)
ORDER BY
 datetime DESC
";
 $result = dbquery($sql);
 echo "<TABLE CLASS=\"MAIL\" WIDTH=100% CELLPADDING=2 CELLSPACING=2>\n";
 echo " <THEAD>\n";
 echo "  <TH>Date/Time</TH>\n";
 echo "  <TH>ID</TH>\n";
 echo "  <TH>From</TH>\n";
 echo "  <TH>To</TH>\n";
 echo "  <TH>Subject</TH>\n";
 echo "  <TH>Size</TH>\n";
 echo "  <TH>SA Score</TH>\n";
 echo "  <TH>Status</TH>\n";
 echo " </THEAD>\n";
 while($row = mysql_fetch_object($result)) {
  // Work out quarantine reason
  $reason = array();
  if($row->isspam == 'Y') { array_push($reason, "Spam"); }
  if($row->virusinfected == 'Y') {
   if(preg_match(VIRUS_REGEX,$row->report,$regs)) {
    array_push($reason, "Virus ($regs[2])");
   } else {
    array_push($reason, "Virus");
   }
  }
  if($row->nameinfected == 'Y') { array_push($reason, "Blocked attachment"); }
  if($row->otherinfected == 'Y') { array_push($reason, "Other infection"); }
  
  // Display
  echo " <TR>\n";
  echo "  <TD>".$row->datetime."</TD>\n";
  echo "  <TD><A HREF=\"detail.php?id=$row->id\">".$row->id."</A></TD>\n";
  echo "  <TD>".htmlentities($row->from_address)."</TD>\n";
  echo "  <TD>".str_replace(",","<BR />",htmlentities($row->to_address))."</TD>\n";
  echo "  <TD>".htmlentities($row->subject)."</TD>\n";
  echo "  <TD>".format_mail_size($row->size)."</TD>\n";
  echo "  <TD>".$row->sascore."</TD>\n";
  echo "  <TD>".join(", ", $reason)."</TD>\n";
  echo " </TR>\n";
 }
 echo "</TABLE>\n";
}

html_end();
?>
