<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require_once('./functions.php');
require_once('DB.php');
require_once('DB/Pager.php');
require_once('./filter.inc');
session_start();
authenticate();
$refresh = html_start("Message Listing");

$dbh = DB::connect(DB_DSN,true);
if (DB::isError($dbh)) { 
 die($dbh->getMessage()); 
}

$sth = $dbh->query("
 SELECT 
  DATE_FORMAT(timestamp, '%d/%m/%y %H:%i:%s') AS datetime, 
  id AS id,
  from_address,
  to_address,
  subject,
  size,
  CASE WHEN isspam=1 THEN 'Y' ELSE 'N' END AS isspam,
  CASE WHEN ishighspam=1 THEN 'Y' ELSE 'N' END AS ishighspam,
  CASE WHEN isrblspam=1 THEN 'Y' ELSE 'N' END AS isrblspam,
  CASE WHEN spamwhitelisted=1 THEN 'Y' ELSE 'N' END AS iswhitelisted,
  sascore,
  CASE WHEN virusinfected=1 THEN 'Y' ELSE 'N' END AS virusinfected,
  CASE WHEN nameinfected=1 THEN 'Y' ELSE 'N' END AS nameinfected,
  CASE WHEN otherinfected=1 THEN 'Y' ELSE 'N' END AS otherinfected,
  report
 FROM
  maillog
 WHERE
  1=1
".$_SESSION["filter"]->CreateSQL()."
 ORDER BY 
  date DESC, time DESC
"); // or die("Error executing query: ".mysql_error());

$offset = intval($_REQUEST['offset']);
$per_page = MAX_RESULTS;

$pager = new DB_Pager($sth, $offset, $per_page);
$data = $pager->build();

// Display table headings
echo "<TABLE CLASS=\"mail\" BORDER=0 WIDTH=100% CELLSPACING=2 CELLPADDING=2>\n";
echo " <THEAD>\n";
echo "  <TH COLSPAN=8>Showing records ". $data['from'] ." to ". $data['to'] ." of ".$data['numrows']."\n";
echo " </THEAD>\n";
echo " <THEAD>\n";
echo "  <TH>Date/Time</TH>\n";
echo "  <TH>ID</TH>\n";
echo "  <TH>From</TH>\n";
echo "  <TH>To</TH>\n";
echo "  <TH>Subject</TH>\n";
echo "  <TH ALIGN=\"CENTER\">Size</TH>\n";
echo "  <TH ALIGN=\"CENTER\">SA Score</TH>\n";
echo "  <TH>Status</TH>\n";
echo " </THEAD>\n";

// Get rows
while($row = $pager->fetchRow(DB_FETCHMODE_OBJECT)) {
 $status_array = array();

 if ($row->isspam == 'Y') {
  array_push($status_array, "Spam");
 } 
 
 if ($row->iswhitelisted == 'Y') {
  array_push($status_array, "Whitelisted");
 }

 if ($row->virusinfected == 'Y') {
  // Get virus name
  if(preg_match(VIRUS_REGEX,$row->report,$virus)) {
   array_push($status_array, "Virus ($virus[2])");
  } else {
   array_push($status_array, "Virus");
  }
 }

 if ($row->nameinfected == 'Y') {
  array_push($status_array, "Blocked attachment");
 }
 
 if ($row->otherinfected == 'Y') {
  array_push($status_array, "Other infection");
 }

 if (count($status_array) == 0) {
  array_push($status_array, "Clean");
 }

 $status = join($status_array,", ");

 # Row colorings
 if ($row->virusinfected == 'Y' || $row->nameinfected == "Y" || $row->otherinfected == "Y") {
  echo " <TR CLASS=\"infected\">\n";
 } elseif ($row->isspam == 'Y') {
  echo " <TR CLASS=\"spam\">\n";
 } elseif ($row->iswhitelisted == 'Y') {
  echo " <TR CLASS=\"whitelisted\">\n";
 } else {
  echo " <TR>";
 }

 echo "  <TD>" 			. $row->datetime		. "</TD>\n";
 echo "  <TD><A HREF=\"detail.php?id=$row->id\">". $row->id. "</A></TD>\n";
 echo "  <TD>" 	. htmlentities($row->from_address) 		. "</TD>\n";
 echo "  <TD>". str_replace(",", "<BR />", htmlentities($row->to_address)) . "</TD>\n";
 echo "  <TD>" 	. htmlentities($row->subject) 		. "</TD>\n";
 echo "  <TD ALIGN=\"RIGHT\">" 	. format_mail_size($row->size)	. "</TD>\n";
 echo "  <TD ALIGN=\"RIGHT\">" 	. $row->sascore			. "</TD>\n";
 echo "  <TD>" 			. $status			. "</TD>\n";
 echo " </TR>\n";
}
echo " <TR><TD COLSPAN=8>\n";
echo "  <TABLE WIDTH=100% BORDER=0><TR>\n";
// Previous page link
printf('<TD ALIGN="CENTER"><A HREF="%s?offset=%d">&lt;&lt;Prev</A></TD><TD ALIGN="CENTER">',$_SERVER['PHP_SELF'],$data['prev']);

// Links to each page
foreach($data['pages'] as $page=>$start) {
 printf('<A HREF="%s?offset=%d">%s</A> ',$_SERVER['PHP_SELF'],$start,$page);
}

// Next page link
printf('</TD><TD ALIGN="CENTER"><A HREF="%s?offset=%d">Next&gt;&gt;</A></TD>',$_SERVER['PHP_SELF'],$data['next']);

echo " </TR></TABLE>\n";
echo "</TD></TR></TABLE>\n";
html_end();
?>
