<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require("./functions.php");
require("./filter.inc");
session_start();
authenticate();

// Continue session
if($_SESSION["filter"]) { $filter = $_SESSION["filter"]; }
 
report_start("SpamAssassin Score Distribution");

$sql = "
 SELECT 
  ROUND(sascore) AS score,
  COUNT(*) AS count
 FROM 
  maillog
 WHERE
  spamwhitelisted=0
".$filter->CreateSQL()."
 GROUP BY
  score
 ORDER BY 
  score
";

# JPGraph
include("./jpgraph/src/jpgraph.php");
include("./jpgraph/src/jpgraph_log.php");
include("./jpgraph/src/jpgraph_bar.php");
include("./jpgraph/src/jpgraph_line.php");

$result = dbquery($sql);
while($row=mysql_fetch_object($result)) {
 $data_labels[] = $row->score;
 $data_count[] = $row->count;
}

$graph = new Graph(750,350,"sa_score_dist.png",0,false);
$graph->SetShadow();
$graph->SetScale("textlin");
$graph->yaxis->SetTitleMargin(40);
$graph->img->SetMargin(60,60,30,70);
$graph->title->Set("SpamAssassin Score Distribution");
$graph->xaxis->title->Set("Score (rounded)");
$graph->xaxis->SetTextLabelInterval(5);
$graph->xaxis->SetTickLabels($data_labels);
$graph->yaxis->title->Set("No. of messages");
$graph->legend->SetLayout(LEGEND_HOR);
$graph->legend->Pos(0.52,0.87,'center');
$bar1 = new LinePlot($data_count);
$bar1->SetFillColor('blue');

$graph->Add($bar1);
$graph->Stroke();

echo "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 HEIGHT=100% WIDTH=100%>\n";
echo " <TR><TD ALIGN=\"CENTER\"><IMG SRC=\"images/mailscannerlogo.gif\"></TD></TR>\n";
echo " <TR>\n";
echo " <TD ALIGN=\"CENTER\"><IMG SRC=\"images/cache/sa_score_dist.png?".time()."\"></TD>\n";
echo " </TR>\n";
echo " <TR>\n";
echo "  <TD ALIGN=\"CENTER\">\n";
echo "<TABLE BORDER=0 WIDTH=500>\n";
echo " <THEAD BGCOLOR=\"#F7CE4A\">\n";
echo "  <TH>Score</TH>\n";
echo "  <TH>Count</TH>\n";
echo " </THEAD>\n";
for($i=0; $i<count($data_count); $i++) {
 echo "<TR BGCOLOR=\"#EBEBEB\">\n";
 echo " <TD ALIGN=\"CENTER\">$data_labels[$i]</TD>\n";
 echo " <TD ALIGN=\"RIGHT\">".number_format($data_count[$i])."</TD>\n";
 echo "</TR>\n";
}
echo "</TABLE>\n";

html_end();
?>
