<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require('./functions.php');
require('./filter.inc');
session_start();
authenticate();

if(isset($_SESSION["filter"])) { $filter = $_SESSION["filter"]; }

report_start("Top Mail Relays");

// JpGraph functions
require("./jpgraph/src/jpgraph.php");
require("./jpgraph/src/jpgraph_pie.php");
require("./jpgraph/src/jpgraph_pie3d.php");

$sql = "
SELECT 
 clientip,
 count(*) AS count,
 sum(virusinfected) AS total_viruses,
 sum(isspam) AS total_spam
FROM 
 maillog 
WHERE
 1=1
".$filter->CreateSQL()."
GROUP BY
 clientip
ORDER BY
 count DESC
LIMIT 10";

$result = dbquery($sql);

$relay_array = array();

while($row = mysql_fetch_object($result)) {
 $data[] = $row->count;
 $hostname = gethostbyaddr($row->clientip);
 if($hostname == $row->clientip) {
  $data_names[] = "(Hostname lookup failed)";
 } else {
  $data_names[] = $hostname;
 }
 $data_ip[] = $row->clientip;
 $data_virus[] = $row->total_viruses;
 $data_spam[] = $row->total_spam;
}

$graph = new PieGraph(750,400,"top_mail_relays.png",0,false);
$graph->SetShadow();
$graph->img->SetAntiAliasing();
$graph->title->Set("Top 10 Mail Relays");

$p1 = new PiePlot3d($data);
$p1->SetTheme('sand');
$p1->SetLegends($data_names);
$p1->SetCenter(0.3);

$graph->Add($p1);
$graph->Stroke();

?>
<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 HEIGHT=100% WIDTH=100%>
<TR>
 <TD ALIGN="CENTER"><IMG SRC="images/mailscannerlogo.gif"></TD>
</TR>
<TR>
 <TD ALIGN="CENTER"><IMG SRC="images/cache/top_mail_relays.png?<?=time()?>"></TD>
</TR>
<TR>
 <TD ALIGN="CENTER">
  <TABLE WIDTH=500>
   <THEAD BGCOLOR="#F7CE4A">
    <TH>Hostname</TH>
    <TH>IP Address</TH>
    <TH>Messages</TH>
    <TH>Viruses</TH>
    <TH>Spam</TH>
   </THEAD> 
<?
for($i=0; $i<count($data_names); $i++) {
 echo "
   <TR BGCOLOR=\"#EBEBEB\">
    <TD>$data_names[$i]</TD>
    <TD>$data_ip[$i]</TD>
    <TD ALIGN=\"RIGHT\">".number_format($data[$i])."</TD>
    <TD ALIGN=\"RIGHT\">".number_format($data_virus[$i])."</TD>
    <TD ALIGN=\"RIGHT\">".number_format($data_spam[$i])."</TD></TR>\n";
}
?>
  </TABLE>
 </TD>
</TR>
</TABLE>
