<?
header("Content-type: text/plain\n\n");
require("./mailscanner/functions.php");

function pad($input) {
 $input = str_pad($input, 70, ".", STR_PAD_RIGHT);
 return $input;
}

// Check that PEAR modules are installed
$modules = "DB DB/Pager Mail Mail/mime";
foreach(split(" ",$modules) as $module) {
 echo pad("Checking for pear module '$module' ");
 if(@include($module.'.php')) {
  echo " OK\n";
 } else {
  echo " FAILED\n";
  $errors[] = "Required PEAR module $module not found";
 }
}
echo "\n";

// Test connectivity to the database
echo pad("Testing connectivity to the database ");
if(($link = @mysql_connect(DB_HOST,DB_USER,DB_PASS)) && @mysql_select_db(DB_NAME)) {
 echo " OK\n";
 // Update schema at this point
 echo "Updating database schema: \n";

 // Create backup of maillog
 echo pad(" - Creating backup of maillog table to maillog_pre");
 $sql = "DROP TABLE maillog_pre";
 @mysql_query($sql); // Don't care if this succeeds or not
 $sql = "CREATE TABLE maillog_pre AS SELECT * FROM maillog WHERE 1=0";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }

 // Update maillog
 echo pad(" - Updating table maillog ");
 if(!@mysql_query("ALTER TABLE maillog ADD COLUMN date DATE")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("ALTER TABLE maillog ADD COLUMN time TIME")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("ALTER TABLE maillog ADD COLUMN headers TEXT")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("CREATE INDEX date_idx ON maillog (date)")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 if(!@mysql_query("UPDATE maillog SET timestamp=timestamp, date=DATE_FORMAT(timestamp, '%Y-%m-%d'), time=DATE_FORMAT(timestamp, '%H:%i:%s')")) {
  die(" ERROR\nMySQL error: ".@mysql_error());
 }
 echo " OK\n";
 
 // Create table inq
 echo pad(" - Creating table 'inq' ");
 $sql = "
CREATE TABLE inq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM ";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }

 // Create table 'outq'
 echo pad(" - Creating table outq ");
 $sql = "
CREATE TABLE outq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM";
 if(@mysql_query($sql)) {
  echo " OK\n";
 } else {
  echo " ERROR\n";
  die("MySQL error: ".@mysql_error());
 }

 // Phew! - finished
 mysql_close($link);
} else {
 echo " FAILED\n";
 $errors[] = "Database connection failed: ".@mysql_error();
}

echo "\n";

// Check MailScanner settings
echo "Checking MailScanner.conf settings: \n";
$check_settings = array(
 'QuarantineInfections' 		=> 'yes',
 'QuarantineWholeMessage' 		=> 'yes',
 'QuarantineWholeMessagesAsQueueFiles' 	=> 'no',
 'DetailedSpamReport' 			=> 'yes',
 'IncludeScoresInSpamAssassinReport' 	=> 'yes',
 'SpamActions' 				=> 'store',
 'HighScoringSpamActions' 		=> 'store',
 'AlwaysLookedUpLast' 			=> '&MailWatchLogging'
);
foreach($check_settings as $setting=>$value) {
 echo pad(" - $setting ");
 if(preg_match('/'.$value.'/',get_conf_var($setting))) {
  echo " OK\n";
 } else {
  echo " WARNING\n";
  $errors[] = "MailScanner.conf: $setting != $value (=".get_conf_var($setting).")";
 }
}
echo "\n";

echo "*** ERROR/WARNING SUMMARY ***\n";
foreach($errors as $error) {
 echo $error."\n";
}
